import { Emitter, ScrollerSyncerInterface, Scroller } from '@fullcalendar/core/internal';

declare class ScrollListener {
    el: HTMLElement;
    emitter: Emitter<any>;
    private isScrolling;
    private isTouching;
    private isRecentlyWheeled;
    private isRecentlyScrolled;
    private wheelWaiter;
    private scrollWaiter;
    constructor(el: HTMLElement);
    destroy(): void;
    private startScroll;
    endScroll(): void;
    handleScroll: () => void;
    _handleScrollWaited(): void;
    handleWheel: () => void;
    _handleWheelWaited(): void;
    handleTouchStart: () => void;
    handleTouchEnd: () => void;
}

declare class ScrollerSyncer implements ScrollerSyncerInterface {
    private isHorizontal;
    private scrollers;
    private scrollListeners;
    private masterEl;
    private isPaused;
    private isRtl;
    constructor(isHorizontal?: boolean);
    handleChildren(scrollers: Scroller[], isRtl: boolean): void;
    destroy(): void;
    get x(): number;
    get y(): number;
    scrollTo({ x, y }: {
        x?: number;
        y?: number;
    }): void;
    bindScroller(el: HTMLElement): ScrollListener;
    assignMaster(el: HTMLElement): void;
}

export { ScrollerSyncer };
